ini: INPUT "Adventure file's name to retrive:", adv$
KEY(12) ON
KEY(13) ON
OPEN adv$ FOR INPUT AS #1

INPUT #1, x$: INPUT #1, directions
INPUT #1, x$: INPUT #1, rooms
INPUT #1, x$: INPUT #1, objects
INPUT #1, x$: INPUT #1, enemies
LINE INPUT #1, cantmove$
LINE INPUT #1, movd$
LINE INPUT #1, canttake$
INPUT #1, ploc

DIM dir$(directions)
DIM rname$(rooms), rdisc$(rooms), rexit(rooms, directions), rpic$(rooms)
DIM oname$(objects), ottl$(objects), odisc$(objects), oloc(objects)
DIM ename$(enemies), ettl$(enemies), edisc$(enemies), eloc(enemies)
DIM etool(enemies), echg(enemies, directions), edmsg$(enemies)
 FOR i = 1 TO directions
  INPUT #1, dir$(i)
 NEXT i

load: INPUT #1, type$
      IF LCASE$(type$) = "room" THEN GOTO iroom
      IF LCASE$(type$) = "obj" THEN GOTO iobj
      IF LCASE$(type$) = "haz" THEN GOTO ihaz
      IF LCASE$(type$) = "end" THEN GOTO start
      IF LCASE$(type$) = "rpic" THEN GOTO ipic
      GOTO load

iroom: INPUT #1, i
  LINE INPUT #1, rname$(i)
  LINE INPUT #1, rdisc$(i)
   FOR j = 1 TO directions
    INPUT #1, rexit(i, j)
   NEXT j
  GOTO load

ipic: INPUT #1, i
      LINE INPUT #1, rpic$(i)
      GOTO load

iobj: INPUT #1, i
   LINE INPUT #1, oname$(i)
   LINE INPUT #1, ottl$(i)
   LINE INPUT #1, odisc$(i)
   INPUT #1, oloc(i)
GOTO load


ihaz: INPUT #1, i
   LINE INPUT #1, ename$(i)
   LINE INPUT #1, ettl$(i)
   LINE INPUT #1, edisc$(i)
   LINE INPUT #1, edmsg$(i)
   INPUT #1, eloc(i)
   INPUT #1, etool(i)
    FOR j = 1 TO directions
     INPUT #1, echg(i, j)
    NEXT j
GOTO load
 
start: CLOSE #1
       SCREEN 1

main: GOSUB proom
      in$ = ""
      PRINT "?";
milp: x$ = INKEY$
      IF x$ = "" THEN GOTO milp
      IF x$ = CHR$(13) THEN GOTO mlpb
      PRINT x$;
      in$ = in$ + x$
      GOTO milp
mlpb: LET in$ = LCASE$(in$)
      CLS
      FOR sp = 1 TO LEN(in$)
       IF MID$(in$, sp, 1) = " " THEN GOTO break
      NEXT sp

break: IF sp = LEN(in$) THEN GOTO wd
      wd2$ = MID$(in$, sp + 1)
wd:   wd1$ = LEFT$(in$, sp - 1)
      IF wd1$ = "go" THEN wd1$ = wd2$
      FOR i = 1 TO directions
        IF wd1$ = dir$(i) THEN GOTO mov
      NEXT i
      IF wd1$ = "look" OR wd1$ = "l" THEN GOTO exam
      IF wd1$ = "use" THEN GOTO oper
      IF wd1$ = "get" OR wd1$ = "take" THEN GOTO take
      IF wd1$ = "drop" THEN GOTO drop
      IF wd1$ = "i" OR wd1$ = "inventory" THEN GOTO invn
      IF wd1$ = "save" THEN GOTO save
      IF wd1$ = "restart" THEN RESTORE: GOTO ini
      IF wd1$ = "quit" OR wd1$ = "exit" THEN SCREEN 0: END
      PRINT "I only understand the phrases:"
      PRINT "go <direction>"
      PRINT "look/examine <noun>"
      PRINT "take/get/drop <noun>"
      PRINT "use <noun>"
      PRINT "save/restart"
      PRINT "quit/exit"
      PRINT "Only two-word commands are accepted."
      PRINT ">Press a key to continue<"
mhld: IF INKEY$ = "" THEN GOTO mhld
      CLS
      GOTO main
      
mov:  IF rexit(ploc, i) = 0 THEN PRINT cantmove$: GOTO main
      ploc = rexit(ploc, i)
      rot = 0
      PRINT movd$; " "; dir$(i); "."
      GOTO main

exam: FOR i = 1 TO enemies
       IF wd2$ = ename$(i) AND eloc(i) = ploc THEN PRINT edisc$(i): GOTO main
      NEXT i

      FOR i = 1 TO objects
       IF wd2$ = oname$(i) AND (oloc(i) = 0 OR oloc(i) = ploc) THEN PRINT odisc$(i): GOTO main
      NEXT i

      PRINT "I don't see that here."
      GOTO main

oper: FOR i = 1 TO objects
       IF wd2$ = oname$(i) THEN GOTO chke
      NEXT i
fail: PRINT "That didn't work."
      GOTO main
chke: IF oloc(i) <> 0 THEN GOTO fail
      FOR j = 1 TO enemies
       IF eloc(j) <> ploc THEN GOTO skip
       IF etool(j) = i THEN GOTO succ
       GOTO fail
skip: NEXT j: GOTO fail
succ: eloc(j) = -1
      PRINT edmsg$(j)
      FOR i = 1 TO directions
      rexit(ploc, i) = echg(j, i)
      NEXT i
      GOTO main

take: FOR i = 1 TO enemies
       IF wd2$ = ename$(i) AND eloc(i) = ploc THEN GOTO tend
      NEXT i
      FOR i = 1 TO objects
       IF wd2$ = oname$(i) AND oloc(i) = ploc THEN GOTO tbrk
      NEXT i
tend: PRINT canttake$
      GOTO main
tbrk: PRINT "You take the "; wd2$; "."
      oloc(i) = 0
      GOTO main

drop: FOR i = 1 TO objects
       IF wd2$ = oname$(i) AND oloc(i) = 0 THEN GOTO dbrk
      NEXT i
      PRINT cantdrop$
      GOTO main
dbrk: PRINT "You drop the "; wd2$; "."
      oloc(i) = ploc
      GOTO main

proom: PRINT : PRINT "---"; rname$(ploc); "---"
       PRINT : PRINT rdisc$(ploc)
       PRINT
       FOR i = 1 TO objects
        IF oloc(i) = ploc AND ottl$(i) <> "" THEN PRINT ottl$(i)
       NEXT i
       FOR i = 1 TO enemies
        IF eloc(i) = ploc AND ettl$(i) <> "" THEN PRINT ettl$(i): GOTO pend
       NEXT i
       rot$ = "TA" + STR$(rot)
       DRAW "X" + VARPTR$(rpic$(ploc))
       DRAW "X" + VARPTR$(rot$)

pend:  PRINT "Now what";
       RETURN


invn: PRINT "You are carrying:": f = 0
      FOR i = 1 TO objects
       IF oloc(i) = 0 THEN PRINT "The "; oname$(i): f = 1
      NEXT i
      IF f = 0 THEN PRINT "Nothing at all."
      GOTO main

rotlt: rot = rot + .1: RETURN
rotrt: rot = rot - .1: RETURN

save:   PRINT "Save as:"
        INPUT adv$
        OPEN adv$ FOR OUTPUT AS #1
        PRINT #1, "dirs", directions
        PRINT #1, "rooms", rooms
        PRINT #1, "objs", objects
        PRINT #1, "hazards", enemies
        PRINT #1, cantmove$
        PRINT #1, movd$
        PRINT #1, canttake$
        PRINT #1, ploc

        FOR i = 1 TO directions
        PRINT #1, dir$(i)
        NEXT i
        FOR i = 1 TO rooms
        PRINT #1, "room,"; i
        PRINT #1, rname$(i)
        PRINT #1, rdisc$(i)
         FOR j = 1 TO directions
         PRINT #1, rexit(i, j)
         NEXT j
        NEXT i
        FOR i = 1 TO objs
        PRINT #1, "obj,"; i
        PRINT #1, oname$(i)
        PRINT #1, odisc$(i)
        PRINT #1, oloc(i)
        NEXT i
        FOR i = 1 TO enemies
        PRINT #1, "haz,"; i
        PRINT #1, ename$(i)
        PRINT #1, edisc$(i)
        PRINT #1, edmsg$(i)
        PRINT #1, eloc(i)
        PRINT #1, etool(i)
         FOR j = 1 TO directions
         PRINT #1, echg(i, j)
         NEXT j
        NEXT i
        PRINT #1, "end"
        CLOSE #1
        PRINT "Save Complete.."
        PRINT "To reload, when starting, enter '"; adv$; "' as the adventure file's name."
        GOTO main

